#include "ppc44x_regs.h"

#define DCR_INDIRECT 1

#define APP_START 0x00000000
#define INDIRECT_MODE_ADDRESS_REGISTER 0x00 /* DCR controller DCR register INDIRECT_MODE_ADDRESS_REGISTER */
#define INDIRECT_MODE_ACCESS_REGISTER 0x01  /* DCR controller DCR register INDIRECT_MODE_ACCESS_REGISTER */
#define TMPL0_XBAR_MAP 0x2d  /* crossbar DCR register TMPL0_XBAR_MAP */
#define TLB0 0x00000290  /* map 0x00000000 (256 MB) in system address space */
#define TLB1 0x0         /* at physical address 0x0 */
#define TLB2 0x7         /* with access control SX=1 SW=1 SR=1 */
#define MI_CONTROL 0x10

	.section ".text"
	.org 0

init:
#if DCR_INDIRECT
	li r0, TMPL0_XBAR_MAP
	mtdcr INDIRECT_MODE_ADDRESS_REGISTER, r0
	lis r0, 0xc000
	ori r0, r0, 0x0000
	mtdcr INDIRECT_MODE_ACCESS_REGISTER, r0    /* map first 256 MB in RAM (through MCI), remaining address space is for devices (MPLB) */
#else
	lis r0, 0xc000
	ori r0, r0, 0x0000
	mtdcr TMPL0_XBAR_MAP, r0    /* map first 256 MB in RAM (through MCI), remaining address space is for devices (MPLB) */
#endif
	mfdcr r0, MI_CONTROL
	oris r0, r0, 0x8000
	mtdcr MI_CONTROL, r0    /* enable MCI */
	li r0, 0          /* TLB entry #0 */
	lis r8, TLB0@h
	ori r8, r8, TLB0@l
	li r9, 0
	mtspr MMUCR, r9   /* MMUCR[STID] = 0 */
	lis r10, TLB1@h
	ori r10, r10, TLB1@l
	lis r11, TLB2@h
	ori r11, r11, TLB2@l
	tlbwe r8, r0, 0   /* Set EPN, V, TS, SIZE, TID of UTLB entry #0 word #0 */
	tlbwe r10, r0, 1  /* Set RPN, ERPN of UTLB entry #0 word #1 */
	tlbwe r11, r0, 2  /* Set U0 U1 U2 U3 W I M G E UX UW UR SX SW SR of UTLB entry #0 word #2 */
	lis r0, APP_START@h
	ori r0, r0, APP_START@l
	mtspr SRR0, r0    /* SRR0 <- entry point */
	li r0, MSR_FP
	mtspr SRR1, r0    /* MSR <- MSR_FP (enable FPU) */
	lis r1, 0x03ff    
	ori r1, r1, 0xfffc    /* stack pointer <- 0x3fffffc (below 64 MB) */
	rfi   /* Branch to entry point and invalidate shadow TLBs */
	
	.global  start
	.org 0xffc
start:
	b init
